#include <kihon.h>
/////////////////////////////////////////////////////////////////////////////////
// 2010.11.30 ver 0.14
// ςȂĂȂ肨DɂǂB
// -----------------------------------------------------------------------------
// cc65@wiki
// http://www34.atwiki.jp/cc65/
/////////////////////////////////////////////////////////////////////////////////

// update : @MIRROR_
// EƗpϐ[y[WɊm
// E֐ŕύXȂconstCqǉ

typedef union LibKihonTmp {
	unsigned char b[4];
	struct {unsigned char i, j, k, l;} bw;
	struct {unsigned int i, j;} w;
} LibKihonTmp;

extern LibKihonTmp kihon_tmp;
#pragma zpsym ("kihon_tmp");  /* kihon_tmp is in the zeropage */

//Rg[mF
void CheckPad(void)
{
    *JOYPAD = 1;
    *JOYPAD = 0;
    kihon.padother= 0;
    for(kihon_tmp.bw.i=0; kihon_tmp.bw.i < 2; kihon_tmp.bw.i++) {
        kihon.padinfo[kihon_tmp.bw.i][1] = kihon.padinfo[kihon_tmp.bw.i][0];
        kihon.padinfo[kihon_tmp.bw.i][0]= 0;
        for(kihon_tmp.bw.j=0; kihon_tmp.bw.j < 8; kihon_tmp.bw.j++) {
            kihon_tmp.bw.k = *(JOYPAD + kihon_tmp.bw.i);
            kihon.padinfo[kihon_tmp.bw.i][0] <<= 1;
            kihon.padinfo[kihon_tmp.bw.i][0] += (kihon_tmp.bw.k & 0x01);
            kihon.padother |= (kihon_tmp.bw.k & 0x0F);
        }
    }
}
 
//{^ςȂ@player:0=1P , 1=2P
unsigned char ButtonDown(const unsigned char player, const unsigned char btn)
{
    if(kihon.padinfo[player][0] & btn) {
        return 1;
    } else {
        return 0;
    }
}
 
//{^
unsigned char ButtonPush(const unsigned char player, const unsigned char btn)
{
    if((kihon.padinfo[player][0] & btn) && ! (kihon.padinfo[player][1] & btn)) {
        return 1;
    } else {
        return 0;
    }
}
 
//}CNEeȂ
unsigned char ControlOther(const unsigned char btn)
{
    if(kihon.padother & btn) {
        return 1;
    } else {
        return 0;
    }
}
 
// PPURg[WX^̏
void InitPPU(void)
{
    *REGIST_PPU_CTRL1 = 0x00;
    *REGIST_PPU_CTRL2 = 0x00;
}
 
// PPURg[WX^̐ݒ
void SetPPU(const unsigned char flag1, const unsigned char flag2)
{
    *REGIST_PPU_CTRL1 = flag1;
    *REGIST_PPU_CTRL2 = flag2;
}
 
// XN[ݒ
void SetScroll(const unsigned char x, const unsigned char y)
{
    *REGIST_SCROLL = x;
    *REGIST_SCROLL = y;
}
 
//wiݒiJԂj
void FillBackground(const unsigned char address1, const unsigned char address2, const unsigned char val, const unsigned char cnt)
{
    *REGIST_ADR = address1;
    *REGIST_ADR = address2;
    kihon_tmp.bw.i = cnt;

    do {
        *REGIST_GRA = val;
    } while(--kihon_tmp.bw.i);
}
 
//wiݒ
void SetBackground(const unsigned char address1, const unsigned char address2, const unsigned char *bg, const unsigned char cnt)
{
    *REGIST_ADR = address1;
    *REGIST_ADR = address2;
    kihon_tmp.bw.i = cnt;
    kihon_tmp.bw.j = 0;
    
    do {
        *REGIST_GRA = *(bg + kihon_tmp.bw.j);
         ++kihon_tmp.bw.j;
    } while (--kihon_tmp.bw.i);
}
 
//WwĩAhXvZ
void GetBackgroundAddress(const unsigned char screen, const unsigned char x, const unsigned char y, unsigned char *ret)
{
    switch (screen) {
    case 0:        //
        kihon_tmp.w.i = 0x2000;
        break;
    case 1:        //E
        kihon_tmp.w.i = 0x2800;
        break;
    case 2:        //
        kihon_tmp.w.i = 0x2400;
        break;
    case 3:        //E
        kihon_tmp.w.i = 0x2c00;
        break;
    }
 
    kihon_tmp.w.i += y * 0x20 + x;
    *(ret + 0) = kihon_tmp.b[0];
    *(ret + 1) = kihon_tmp.b[1];
}

//pbgݒ
void SetPalette(const unsigned char *palette, const unsigned char sprite)
{
    *REGIST_ADR = 0x3f;
    if (sprite) {
        *REGIST_ADR = 0x10;
    } else {
        *REGIST_ADR = 0x00;
    }

    for (kihon_tmp.bw.i = 0; kihon_tmp.bw.i < 16; kihon_tmp.bw.i++)
    {
        *REGIST_GRA = *(palette + kihon_tmp.bw.i);
    }
}

//XvCgݒ
void SetSprite(const unsigned char first, const unsigned char x, const unsigned char y, const unsigned char index, const unsigned char flag)
{
    if (first) {
        *REGIST_SPR_ADR=0x00;
    }
    *REGIST_SPR_GRA=y;
    *REGIST_SPR_GRA=index;
    *REGIST_SPR_GRA=flag;
    *REGIST_SPR_GRA=x;
}
 
//DMA]̈揉
void InitDMA(unsigned char *address)
{
    kihon_tmp.bw.i = 0;

    do {
        --kihon_tmp.bw.i;
        *(address + kihon_tmp.bw.i)=0;
    } while (kihon_tmp.bw.i);
}
 
//DMA]
void SetDMA(unsigned char *address, const unsigned char first, const unsigned char x, const unsigned char y, const unsigned char index, const unsigned char flag)
{
    static unsigned char cnt;
    if (first) { cnt = 0; }
    *(address + cnt + 0)=y;
    *(address + cnt + 1)=index;
    *(address + cnt + 2)=flag;
    *(address + cnt + 3)=x;
    cnt+=4;
}

//DMA]
void SendDMA(const unsigned char address)
{
    *REGIST_DMA = address;
}

//VBlank҂
void VBlank(void)
{
    while (! (*REGIST_PPU_STS & 0x80) );
}

//Oe҂
void ZeroSprite(void)
{
    while (  (*REGIST_PPU_STS & 0x40) );
    while (! (*REGIST_PPU_STS & 0x40) );
}


/******************************************************************************************************************************
kihon.h̉

    CheckPadFRg[̊mFB{IɖĂяoB
    ButtonDownFꂽ{^̊mFBij
    ButtonPushFꂽ{^̊mFBij
    ControlOtherF}CNEe̊mFB
    InitPPUFPPURg[WX^̏B
    SetPPUFPPURg[WX^̐ݒB
        flag1FPPURg[WX^P̐ݒB
            bit7FVBlankNMIs
            bit6FPPU}X^[/X[uZNg
            bit5FXvCgTCY(0:8x8,1:8x16)
            bit4FBGp^[e[uAhX(0:$0000,1:$1000)
            bit3FXvCgp^[e[uAhX(0:$0000,1:$1000)
            bit2FPPUAhXCNg(0:+1,1:+32)
            bit0,1F\l[e[uAhXԍi00F$2000EA01F$2400EA10F$2800EEA11F$2C00EEj
        flag2FPPURg[WX^Q̐ݒB
            bit5-7Fbit0=1̂ƂwiF/bit0=1̂ƂF
            000:ȂE001:΁E010:E100:(ȊO͕̐s)
            bit4FXvCg\(0:\,1:\)
            bit3FBG\(0:\,1:\)
            bit2FXvCgNbv(0:ʂ̍Whbg\Ȃ,1:NbvȂ)
            bit1FBGNbv(0:ʂ̍Whbg\Ȃ,1:NbvȂ)
            bit0FfBXvC^Cv(0:J[,1:mN)
    SetScrollFwĩXN[B
        xFʒuB
        yFcʒuB
    FillBackgroundFwi̐ݒiJԂjB
        address1Fo͊JnʒuiʂQoCgj
        address2Fo͊JnʒuiʂQoCgj
        valFo͓ei}X̔ԍj
        cntFo͂JԂ
    SetBackgroundFwi̐ݒB
        address1Fo͊JnʒuiʂQoCgj
        address2Fo͊JnʒuiʂQoCgj
        *bgFo͓ẽ|C^
        cntFo͓ẽoCg
    GetBackgroundAddressFWwĩAhXZoB
        screenF(0:E,1:E,2:,3:E)
        xFʒuB
        yFcʒuB
        *retFAhXi[PoCg~Q̔z
    SetPaletteFpbg̐ݒB
        *paletteFpbgẽ|C^
        spriteFOFwippbg@PFXvCgppbg
    FillAttributeFiwiS}X~S}Xɂǂ̃pbggj̐ݒBiJԂj
        address1Fo͐iʂQoCgj
        address2Fo͐iʂQoCgj
        valFo͓e
        cntFo͂JԂ
    SetAttributeFiwiS}X~S}Xɂǂ̃pbggj̐ݒB
        address1Fo͐iʂQoCgj
        address2Fo͐iʂQoCgj
        *atrFo͓ẽ|C^
        cntFo͓ẽoCg
    SetSpriteFXvCg̐ݒB
        firstF1=Pڂ̃XvCg 0=Qڈȍ~
        xFʒu
        yFcʒu
        indexFR}ڂ̉摜\邩
        flagF\@
            7bitF㉺]
            6bitFE]
            5bitFwiɕ\
            0,1bitFpbgԍ
    SetDMAFDMA]BiXvCgp̈̐ݒj
        *addressFXvCgp̈̊JnAhX
        firstF1=Pڂ̃XvCg 0=Qڈȍ~
        x,y,index,flagFSetSpriteƓeB
    SendDMAFDMA]
        addressFXvCgp̈̊JnAhX̎O 0x1=0x0100
    VBlankFVBlank҂B
    ZeroSpriteFOe҂B

SetRegisterESetBackgroundESetAttributeESetPalette͕֋X㕪Ă邾ŁAĂ鏈͓łB
FillBackgroundFillAttributelB

ӎ

    SetBackgroundɂ`悪ԂɍȂꍇAwi܂ɕ\܂B

@VBlank()
@SetBackground(0x20,0x00,(char *)bg,32);
@SetScroll( 0, 0 );
 

    ꎞIɔwi̕`~ÅԂɕ`悷邱Ƃŉł܂B

@SetPPU(0x08,0x06);
@SetBackground(0x20,0x00,(char *)bg,32);
@SetScroll( 0, 0 );
@SetPPU(0x08,0x1e);
 

    `悷͈͂߂邱Ƃłł܂B

@VBlank();
@SetBackground(0x20,0x00,(char *)bg,10)
@SetScroll( 0, 0 );
@VBlank();
@SetBackground(0x20,0x0a,(char *)bg,10)
@SetScroll( 0, 0 );
@VBlank();
@SetBackground(0x20,0x14,(char *)bg,12)
@SetScroll( 0, 0 );
 

    SetBackgroundĂяoɃx^ɏƂʓIłB
    i#define̎gp͖肠܂Bj

@*REGIST_ADR = 0x20;
@*REGIST_ADR = 0x00;
@*REGIST_GRA = 0;
@*REGIST_GRA = 1;
@     :
@     :
@*REGIST_GRA = 31;
******************************************************************************************************************************/
